package ru.ulstu.extractor.ts.creator;

import org.springframework.stereotype.Component;
import ru.ulstu.extractor.gitrepository.service.GitRepositoryService;
import ru.ulstu.extractor.ts.model.TimeSeries;
import ru.ulstu.extractor.ts.model.TimeSeriesType;
import ru.ulstu.extractor.ts.service.TimeSeriesService;
import ru.ulstu.extractor.ts.util.Dummy;

import java.util.Collections;
import java.util.List;

@Component
public class ClassTS extends AbstractTimeSeriesCreator {
    private final TimeSeriesService timeSeriesService;

    private final GitRepositoryService gitRepositoryService;

    public ClassTS(TimeSeriesService timeSeriesService, GitRepositoryService gitRepositoryService) {
        this.timeSeriesService = timeSeriesService;
        this.gitRepositoryService = gitRepositoryService;
    }

    @Override
    public List<TimeSeries> getTimeSeries(Integer repositoryId, String branchName) {
        return Collections.singletonList(
                new TimeSeries(
                        String.format("%s %s %s",
                                gitRepositoryService.findById(repositoryId).getName(),
                                branchName,
                                getTimeSeriesType().getDescription()),
                        getTimeSeriesType(),
                        Dummy.getDefaultTimeSeries()));
    }

    @Override
    public TimeSeriesService getTimeSeriesService() {
        return timeSeriesService;
    }

    @Override
    public TimeSeriesType getTimeSeriesType() {
        return TimeSeriesType.CLASSES;
    }
}
